<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>audio controller</title>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.9.4/css/bulma.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bulma-helpers/0.4.3/css/bulma-helpers.min.css"
    integrity="sha512-U6ELnUi7oqVEjkLmFw5r5UR5LEtvpImS/jUykBKneVhD0lxZxfJZ3k3pe003ktrtNZYungd9u3Urp2X09wKwXg=="
    crossorigin="anonymous" referrerpolicy="no-referrer" />

  <script src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
  <script src="https://unpkg.com/react@18/umd/react.development.js" crossorigin></script>
  <script src="https://unpkg.com/react-dom@18/umd/react-dom.development.js" crossorigin></script>
</head>

<body>
  <div id="main" />

  <script type="text/babel">
    const { useState, useMemo } = React;
    const domContainer = document.querySelector("#main");
    const root = ReactDOM.createRoot(domContainer);

    const songs = [
      {
        kind: "Calm", values: [
          "alleycat",
          ["beneath-the-mask", "beneath-the-mask-alt"],
          "break-it-down",
          "ideal-and-the-real",
          "life-goes-on",
          "short-rest",
          "tokyo-night"
        ]
      },
      {
        kind: "Shop", values: [
          "butterfly-kiss",
          "kijijoji-199x",
          "layer-cake",
          "phantom",
          "so-boring"
        ]
      },
      {
        kind: "DungeonHigh", values: [
          "ark",
          ["price", "price-alt"]
        ]
      },
      {
        kind: "DungeonLow", values: [
          ["a-woman", "a-woman-alt"],
          "freedom-and-peace",
          "gentle-madman",
          "when-mother-was-there"
        ]
      },
      {
        kind: "Battle", values: [
          ["blooming-villian", "blooming-villian-alt"],
          "keeper-of-lust",
          "prison-labor",
          "rivers-in-the-desert",
          "will-power"
        ]
      },
      {
        kind: "BattleBoss", values: [
          "keep-your-faith",
          "life-will-change",
          "cinder-soul"
        ]
      },
      {
        kind: "Stealth", values: [
          "disquiet"
        ]
      },
      {
        kind: "Triumphant", values: [
          "our-beginning",
          "sunset-bridge",
          "swear-to-my-bones"
        ]
      }
    ];

    function style(kind, isPlaying) {
      const playingStyle = (() => {
        if (isPlaying) {
          return "had-border-width-3"
        }

        return "is-borderless";
      })();

      const kindStyle = (() => {
        switch (kind) {
          case "Calm": return "has-background-info-dark has-text-white-bis";
          case "Shop": return "has-background-primary-dark has-text-white-bis";
          case "DungeonHigh": return "has-background-warning-dark has-text-white-bis";
          case "DungeonLow": return "has-background-warning has-text-black-ter";
          case "BattleBoss": return "has-background-danger-dark has-text-white-bis";
          case "Battle": return "has-background-danger has-text-white-bis";
          case "Stealth": return "has-background-success-dark has-text-white-bis";
          case "Triumphant": return "has-background-link-dark has-text-white-bis";
        }
      })();

      return `${kindStyle} ${playingStyle}`;
    }

    function play(kind, idx, isAlt) {
      const _ = fetch("/play", {
        method: "POST",
        headers: {
          "Accept": "application/json",
          "Content-Type": "application/json"
        },
        body: `{
          "song": "${kind}${idx}${isAlt ? "Alt" : ""}"
        }`
      }).then();
    }

    function SongButtonSingle({ kind, value, idx, currentlyPlaying, setCurrentlyPlaying }) {
      const classExtras = useMemo(() => style(kind, value == currentlyPlaying), [kind, value, currentlyPlaying]);

      return (<div className="column is-2">
        <div
          className={`box ${classExtras}`}
          style={{ cursor: "pointer" }}
          onClick={() => {
            console.log(currentlyPlaying);
            play(kind, idx, false);
            if (currentlyPlaying !== null && currentlyPlaying === value) {
              setCurrentlyPlaying(null);
            } else {
              setCurrentlyPlaying(value);
            }
          }}
        >
          <span className="tag">{kind}</span>
          <br />
          <span>{value}</span>
        </div>
      </div>);
    }

    function SongButtonMulti({ kind, values, idx, currentlyPlaying, setCurrentlyPlaying }) {
      return (<div className="column is-2">
        <div className="tile is-ancestor">
          <div className="tile is-vertical is-parent">
            <div
              className="tile is-child"
              style={{ cursor: "pointer" }}
              onClick={() => play(kind, idx, false)}
            >
              <div className={`box ${style(kind)}`}>
                <span className="tag">{kind}</span>
                <br />
                <span>{values[0]}</span>
              </div>
            </div>
            <div
              className="tile is-child"
              style={{ cursor: "pointer" }}
              onClick={() => play(kind, idx, true)}
            >
              <div className={`box ${style(kind)}`}>
                <span className="tag">{kind}</span>
                <br />
                <span>{values[1]}</span>
              </div>
            </div>
          </div>
        </div>
      </div>);
    }

    function ButtonsParent() {
      const [currentlyPlaying, setCurrentlyPlaying] = useState(null);

      return (<div className="container">
        <div className="columns is-multiline">
          {songs.flatMap(({ kind, values }) => {
            return values.map((value, idx) => {
              if (typeof value === 'string' || value instanceof String) {
                return (<SongButtonSingle key={`${kind}${idx}`} kind={kind} value={value} idx={idx + 1} currentlyPlaying={currentlyPlaying} setCurrentlyPlaying={setCurrentlyPlaying} />);
              } else {
                return (<SongButtonMulti key={`${kind}${idx}`} kind={kind} values={value} idx={idx + 1} currentlyPlaying={currentlyPlaying} setCurrentlyPlaying={setCurrentlyPlaying} />);
              }
            });
          })}
        </div>
      </div>);
    }

    root.render(<div>
      <section className="hero">
        <div className="hero-body" />
      </section>
      <ButtonsParent />
    </div>);
  </script>
</body>

</html>